# coding: utf-8

"""
    Control-M Services

    Provides access to BMC Control-M Services  # noqa: E501

    OpenAPI spec version: 9.18.3
    Contact: support@bmc.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from controlm_client.models.allowed_job_actions import AllowedJobActions  # noqa: F401,E501
from controlm_client.models.allowed_jobs import AllowedJobs  # noqa: F401,E501
from controlm_client.models.folder_auth import FolderAuth  # noqa: F401,E501
from controlm_client.models.privilege_name import PrivilegeName  # noqa: F401,E501
from controlm_client.models.privilege_name_controlm import PrivilegeNameControlm  # noqa: F401,E501
from controlm_client.models.privileges import Privileges  # noqa: F401,E501
from controlm_client.models.runas_user_auth import RunasUserAuth  # noqa: F401,E501
from controlm_client.models.service_auth import ServiceAuth  # noqa: F401,E501


class RoleData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'name': 'str',
        'description': 'str',
        'allowed_jobs': 'AllowedJobs',
        'allowed_job_actions': 'AllowedJobActions',
        'privileges': 'Privileges',
        'folders': 'list[FolderAuth]',
        'calendars': 'list[PrivilegeNameControlm]',
        'runas_users': 'list[RunasUserAuth]',
        'workload_policies': 'list[PrivilegeName]',
        'site_standard': 'list[PrivilegeName]',
        'site_customization': 'list[PrivilegeName]',
        'services': 'list[ServiceAuth]',
        'events': 'list[PrivilegeNameControlm]',
        'mutexes': 'list[PrivilegeNameControlm]',
        'semaphores': 'list[PrivilegeNameControlm]',
        'global_events': 'list[PrivilegeName]'
    }

    attribute_map = {
        'name': 'Name',
        'description': 'Description',
        'allowed_jobs': 'AllowedJobs',
        'allowed_job_actions': 'AllowedJobActions',
        'privileges': 'Privileges',
        'folders': 'Folders',
        'calendars': 'Calendars',
        'runas_users': 'RunasUsers',
        'workload_policies': 'WorkloadPolicies',
        'site_standard': 'SiteStandard',
        'site_customization': 'SiteCustomization',
        'services': 'Services',
        'events': 'Events',
        'mutexes': 'Mutexes',
        'semaphores': 'Semaphores',
        'global_events': 'GlobalEvents'
    }

    def __init__(self, name=None, description=None, allowed_jobs=None, allowed_job_actions=None, privileges=None, folders=None, calendars=None, runas_users=None, workload_policies=None, site_standard=None, site_customization=None, services=None, events=None, mutexes=None, semaphores=None, global_events=None):  # noqa: E501
        """RoleData - a model defined in Swagger"""  # noqa: E501

        self._name = None
        self._description = None
        self._allowed_jobs = None
        self._allowed_job_actions = None
        self._privileges = None
        self._folders = None
        self._calendars = None
        self._runas_users = None
        self._workload_policies = None
        self._site_standard = None
        self._site_customization = None
        self._services = None
        self._events = None
        self._mutexes = None
        self._semaphores = None
        self._global_events = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if allowed_jobs is not None:
            self.allowed_jobs = allowed_jobs
        if allowed_job_actions is not None:
            self.allowed_job_actions = allowed_job_actions
        if privileges is not None:
            self.privileges = privileges
        if folders is not None:
            self.folders = folders
        if calendars is not None:
            self.calendars = calendars
        if runas_users is not None:
            self.runas_users = runas_users
        if workload_policies is not None:
            self.workload_policies = workload_policies
        if site_standard is not None:
            self.site_standard = site_standard
        if site_customization is not None:
            self.site_customization = site_customization
        if services is not None:
            self.services = services
        if events is not None:
            self.events = events
        if mutexes is not None:
            self.mutexes = mutexes
        if semaphores is not None:
            self.semaphores = semaphores
        if global_events is not None:
            self.global_events = global_events

    @property
    def name(self):
        """Gets the name of this RoleData.  # noqa: E501

        role name  # noqa: E501

        :return: The name of this RoleData.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this RoleData.

        role name  # noqa: E501

        :param name: The name of this RoleData.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this RoleData.  # noqa: E501

        role description  # noqa: E501

        :return: The description of this RoleData.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this RoleData.

        role description  # noqa: E501

        :param description: The description of this RoleData.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def allowed_jobs(self):
        """Gets the allowed_jobs of this RoleData.  # noqa: E501


        :return: The allowed_jobs of this RoleData.  # noqa: E501
        :rtype: AllowedJobs
        """
        return self._allowed_jobs

    @allowed_jobs.setter
    def allowed_jobs(self, allowed_jobs):
        """Sets the allowed_jobs of this RoleData.


        :param allowed_jobs: The allowed_jobs of this RoleData.  # noqa: E501
        :type: AllowedJobs
        """

        self._allowed_jobs = allowed_jobs

    @property
    def allowed_job_actions(self):
        """Gets the allowed_job_actions of this RoleData.  # noqa: E501


        :return: The allowed_job_actions of this RoleData.  # noqa: E501
        :rtype: AllowedJobActions
        """
        return self._allowed_job_actions

    @allowed_job_actions.setter
    def allowed_job_actions(self, allowed_job_actions):
        """Sets the allowed_job_actions of this RoleData.


        :param allowed_job_actions: The allowed_job_actions of this RoleData.  # noqa: E501
        :type: AllowedJobActions
        """

        self._allowed_job_actions = allowed_job_actions

    @property
    def privileges(self):
        """Gets the privileges of this RoleData.  # noqa: E501


        :return: The privileges of this RoleData.  # noqa: E501
        :rtype: Privileges
        """
        return self._privileges

    @privileges.setter
    def privileges(self, privileges):
        """Sets the privileges of this RoleData.


        :param privileges: The privileges of this RoleData.  # noqa: E501
        :type: Privileges
        """

        self._privileges = privileges

    @property
    def folders(self):
        """Gets the folders of this RoleData.  # noqa: E501


        :return: The folders of this RoleData.  # noqa: E501
        :rtype: list[FolderAuth]
        """
        return self._folders

    @folders.setter
    def folders(self, folders):
        """Sets the folders of this RoleData.


        :param folders: The folders of this RoleData.  # noqa: E501
        :type: list[FolderAuth]
        """

        self._folders = folders

    @property
    def calendars(self):
        """Gets the calendars of this RoleData.  # noqa: E501


        :return: The calendars of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeNameControlm]
        """
        return self._calendars

    @calendars.setter
    def calendars(self, calendars):
        """Sets the calendars of this RoleData.


        :param calendars: The calendars of this RoleData.  # noqa: E501
        :type: list[PrivilegeNameControlm]
        """

        self._calendars = calendars

    @property
    def runas_users(self):
        """Gets the runas_users of this RoleData.  # noqa: E501


        :return: The runas_users of this RoleData.  # noqa: E501
        :rtype: list[RunasUserAuth]
        """
        return self._runas_users

    @runas_users.setter
    def runas_users(self, runas_users):
        """Sets the runas_users of this RoleData.


        :param runas_users: The runas_users of this RoleData.  # noqa: E501
        :type: list[RunasUserAuth]
        """

        self._runas_users = runas_users

    @property
    def workload_policies(self):
        """Gets the workload_policies of this RoleData.  # noqa: E501


        :return: The workload_policies of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeName]
        """
        return self._workload_policies

    @workload_policies.setter
    def workload_policies(self, workload_policies):
        """Sets the workload_policies of this RoleData.


        :param workload_policies: The workload_policies of this RoleData.  # noqa: E501
        :type: list[PrivilegeName]
        """

        self._workload_policies = workload_policies

    @property
    def site_standard(self):
        """Gets the site_standard of this RoleData.  # noqa: E501


        :return: The site_standard of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeName]
        """
        return self._site_standard

    @site_standard.setter
    def site_standard(self, site_standard):
        """Sets the site_standard of this RoleData.


        :param site_standard: The site_standard of this RoleData.  # noqa: E501
        :type: list[PrivilegeName]
        """

        self._site_standard = site_standard

    @property
    def site_customization(self):
        """Gets the site_customization of this RoleData.  # noqa: E501


        :return: The site_customization of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeName]
        """
        return self._site_customization

    @site_customization.setter
    def site_customization(self, site_customization):
        """Sets the site_customization of this RoleData.


        :param site_customization: The site_customization of this RoleData.  # noqa: E501
        :type: list[PrivilegeName]
        """

        self._site_customization = site_customization

    @property
    def services(self):
        """Gets the services of this RoleData.  # noqa: E501


        :return: The services of this RoleData.  # noqa: E501
        :rtype: list[ServiceAuth]
        """
        return self._services

    @services.setter
    def services(self, services):
        """Sets the services of this RoleData.


        :param services: The services of this RoleData.  # noqa: E501
        :type: list[ServiceAuth]
        """

        self._services = services

    @property
    def events(self):
        """Gets the events of this RoleData.  # noqa: E501


        :return: The events of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeNameControlm]
        """
        return self._events

    @events.setter
    def events(self, events):
        """Sets the events of this RoleData.


        :param events: The events of this RoleData.  # noqa: E501
        :type: list[PrivilegeNameControlm]
        """

        self._events = events

    @property
    def mutexes(self):
        """Gets the mutexes of this RoleData.  # noqa: E501


        :return: The mutexes of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeNameControlm]
        """
        return self._mutexes

    @mutexes.setter
    def mutexes(self, mutexes):
        """Sets the mutexes of this RoleData.


        :param mutexes: The mutexes of this RoleData.  # noqa: E501
        :type: list[PrivilegeNameControlm]
        """

        self._mutexes = mutexes

    @property
    def semaphores(self):
        """Gets the semaphores of this RoleData.  # noqa: E501


        :return: The semaphores of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeNameControlm]
        """
        return self._semaphores

    @semaphores.setter
    def semaphores(self, semaphores):
        """Sets the semaphores of this RoleData.


        :param semaphores: The semaphores of this RoleData.  # noqa: E501
        :type: list[PrivilegeNameControlm]
        """

        self._semaphores = semaphores

    @property
    def global_events(self):
        """Gets the global_events of this RoleData.  # noqa: E501


        :return: The global_events of this RoleData.  # noqa: E501
        :rtype: list[PrivilegeName]
        """
        return self._global_events

    @global_events.setter
    def global_events(self, global_events):
        """Sets the global_events of this RoleData.


        :param global_events: The global_events of this RoleData.  # noqa: E501
        :type: list[PrivilegeName]
        """

        self._global_events = global_events

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(RoleData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RoleData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
